org.apache.geode.management

## Interface GatewaySenderMXBean

-     public interface GatewaySenderMXBean

  MBean that provides access to information and management functionality for a `GatewaySender`.
  Since:
    GemFire 7.0

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getAlertThreshold()` Returns the alert threshold for entries in a GatewaySender's queue.The default value is 0 milliseconds in which case no alert will be logged if events are delayed in Queue.
    `long` | `getAverageDistributionTimePerBatch()` Returns the average time taken to send a batch of events.
    `float` | `getBatchesDispatchedRate()` Returns the average number of batches sent per second.
    `int` | `getBatchSize()` Returns the size of a batch that gets delivered by the GatewaySender.
    `long` | `getBatchTimeInterval()` Returns the interval between transmissions by the GatewaySender.
    `long` | `getBytesOverflowedToDisk()` Returns the number of bytes overflowed to disk for this Sender.
    `int` | `getDispatcherThreads()` Returns the number of dispatcher threads working for this `GatewaySender`.
    `long` | `getEntriesOverflowedToDisk()` Returns the number of entries overflowed to disk for this Sender.
    `int` | `getEventQueueSize()` Returns the current size of the event queue.
    `int` | `getEventsExceedingAlertThreshold()` Returns number of events which have exceeded the configured alert threshold.
    `float` | `getEventsQueuedRate()` Returns the rate of events being queued.
    `float` | `getEventsReceivedRate()` Returns the rate of events received per second by this Sender.
    `java.lang.String[]` | `getGatewayEventFilters()` Returns a list of `GatewayEventFilter`s added to this GatewaySender.
    `java.lang.String` | `getGatewayReceiver()` Returns the host and port information of GatewayReceiver to which this gateway sender is connected.
    `java.lang.String[]` | `getGatewayTransportFilters()` Returns a list of `GatewayTransportFilter`s added to this GatewaySender.
    `float` | `getLRUEvictionsRate()` Returns the rate of LRU evictions per second by this Sender.
    `int` | `getMaximumQueueMemory()` Returns the maximum memory after which the data needs to be overflowed to disk.
    `java.lang.String` | `getOrderPolicy()` Returns the order policy followed while dispatching the events to remote distributed system.
    `java.lang.String` | `getOverflowDiskStoreName()` Returns the name of the disk store that is used for persistence.
    `int` | `getRemoteDSId()` Returns the id of the remote `GatewayReceiver`'s DistributedSystem.
    `java.lang.String` | `getSenderId()` Returns the ID of the GatewaySender.
    `int` | `getSocketBufferSize()` Returns the configured buffer size of the socket connection between this GatewaySender and its receiving `GatewayReceiver`.
    `long` | `getSocketReadTimeout()` Returns the amount of time (in milliseconds) that a socket read between a sending GatewaySender and its receiving `GatewayReceiver` is allowed to block.
    `int` | `getTotalBatchesRedistributed()` Returns the total number of batches of events that were resent.
    `int` | `getTotalEventsConflated()` Returns the number of events received, but not added to the event queue, because the queue already contains an event with the same key.
    `boolean` | `isBatchConflationEnabled()` Returns whether batch conflation for the GatewaySender's queue is enabled
    `boolean` | `isConnected()` Returns whether this GatewaySender is connected and sending data to a GatewayReceiver.
    `boolean` | `isDiskSynchronous()` Returns whether the isDiskSynchronous property is set for this GatewaySender.
    `boolean` | `isManualStart()` Returns whether the GatewaySender is configured for manual start.
    `boolean` | `isParallel()` Returns whether the isParallel property is set for this GatewaySender.
    `boolean` | `isPaused()` Returns whether or not this GatewaySender is paused.
    `boolean` | `isPersistenceEnabled()` Returns whether the GatewaySender is configured to be persistent or non-persistent.
    `boolean` | `isPrimary()` Returns whether this GatewaySender is primary or secondary.
    `boolean` | `isRunning()` Returns whether or not this GatewaySender is running.
    `void` | `pause()` Pauses this GatewaySender.
    `void` | `rebalance()` Rebalances this GatewaySender.
    `void` | `resume()` Resumes this paused GatewaySender.
    `void` | `start()` Starts this GatewaySender.
    `void` | `stop()` Stops this GatewaySender.

- - ### Method Detail

    - #### getSenderId

          java.lang.String getSenderId()

      Returns the ID of the GatewaySender.

    - #### getRemoteDSId

          int getRemoteDSId()

      Returns the id of the remote `GatewayReceiver`'s DistributedSystem.

    - #### getSocketBufferSize

          int getSocketBufferSize()

      Returns the configured buffer size of the socket connection between this GatewaySender and its receiving `GatewayReceiver`.

    - #### getSocketReadTimeout

          long getSocketReadTimeout()

      Returns the amount of time (in milliseconds) that a socket read between a sending GatewaySender and its receiving `GatewayReceiver` is allowed to block.

    - #### getOverflowDiskStoreName

          java.lang.String getOverflowDiskStoreName()

      Returns the name of the disk store that is used for persistence.

    - #### getMaximumQueueMemory

          int getMaximumQueueMemory()

      Returns the maximum memory after which the data needs to be overflowed to disk.

    - #### getBatchSize

          int getBatchSize()

      Returns the size of a batch that gets delivered by the GatewaySender.

    - #### getBatchTimeInterval

          long getBatchTimeInterval()

      Returns the interval between transmissions by the GatewaySender.

    - #### isBatchConflationEnabled

          boolean isBatchConflationEnabled()

      Returns whether batch conflation for the GatewaySender's queue is enabled
      Returns:
        True if batch conflation is enabled, false otherwise.

    - #### isPersistenceEnabled

          boolean isPersistenceEnabled()

      Returns whether the GatewaySender is configured to be persistent or non-persistent.
      Returns:
        True if the sender is persistent, false otherwise.

    - #### getAlertThreshold

          int getAlertThreshold()

      Returns the alert threshold for entries in a GatewaySender's queue.The default value is 0 milliseconds in which case no alert will be logged if events are delayed in Queue.

    - #### getGatewayEventFilters

          java.lang.String[] getGatewayEventFilters()

      Returns a list of `GatewayEventFilter`s added to this GatewaySender.

    - #### getGatewayTransportFilters

          java.lang.String[] getGatewayTransportFilters()

      Returns a list of `GatewayTransportFilter`s added to this GatewaySender.

    - #### isManualStart

          boolean isManualStart()

      Returns whether the GatewaySender is configured for manual start.
      Returns:
        True if the GatewaySender is configured for manual start, false otherwise.

    - #### isRunning

          boolean isRunning()

      Returns whether or not this GatewaySender is running.
      Returns:
        True if the GatewaySender is running, false otherwise.

    - #### isPaused

          boolean isPaused()

      Returns whether or not this GatewaySender is paused.
      Returns:
        True of the GatewaySender is paused, false otherwise.

    - #### getEventsReceivedRate

          float getEventsReceivedRate()

      Returns the rate of events received per second by this Sender.

    - #### getEventsQueuedRate

          float getEventsQueuedRate()

      Returns the rate of events being queued.

    - #### getLRUEvictionsRate

          float getLRUEvictionsRate()

      Returns the rate of LRU evictions per second by this Sender.

    - #### getEntriesOverflowedToDisk

          long getEntriesOverflowedToDisk()

      Returns the number of entries overflowed to disk for this Sender.

    - #### getBytesOverflowedToDisk

          long getBytesOverflowedToDisk()

      Returns the number of bytes overflowed to disk for this Sender.

    - #### getEventQueueSize

          int getEventQueueSize()

      Returns the current size of the event queue.

    - #### getTotalEventsConflated

          int getTotalEventsConflated()

      Returns the number of events received, but not added to the event queue, because the queue already contains an event with the same key.

    - #### getBatchesDispatchedRate

          float getBatchesDispatchedRate()

      Returns the average number of batches sent per second.

    - #### getAverageDistributionTimePerBatch

          long getAverageDistributionTimePerBatch()

      Returns the average time taken to send a batch of events.

    - #### getTotalBatchesRedistributed

          int getTotalBatchesRedistributed()

      Returns the total number of batches of events that were resent.

    - #### start

          void start()

      Starts this GatewaySender. Once the GatewaySender is running its configuration cannot be changed.

    - #### stop

          void stop()

      Stops this GatewaySender.

    - #### pause

          void pause()

      Pauses this GatewaySender.

    - #### resume

          void resume()

      Resumes this paused GatewaySender.

    - #### rebalance

          void rebalance()

      Rebalances this GatewaySender.

    - #### isPrimary

          boolean isPrimary()

      Returns whether this GatewaySender is primary or secondary.
      Returns:
        True if this is the primary, false otherwise.

    - #### getDispatcherThreads

          int getDispatcherThreads()

      Returns the number of dispatcher threads working for this `GatewaySender`.

    - #### getOrderPolicy

          java.lang.String getOrderPolicy()

      Returns the order policy followed while dispatching the events to remote distributed system. Order policy is only relevant when the number of dispatcher threads is greater than one.

    - #### isDiskSynchronous

          boolean isDiskSynchronous()

      Returns whether the isDiskSynchronous property is set for this GatewaySender.
      Returns:
        True if the property is set, false otherwise.

    - #### isParallel

          boolean isParallel()

      Returns whether the isParallel property is set for this GatewaySender.
      Returns:
        True if the property is set, false otherwise.

    - #### getGatewayReceiver

          java.lang.String getGatewayReceiver()

      Returns the host and port information of GatewayReceiver to which this gateway sender is connected.

    - #### isConnected

          boolean isConnected()

      Returns whether this GatewaySender is connected and sending data to a GatewayReceiver.

    - #### getEventsExceedingAlertThreshold

          int getEventsExceedingAlertThreshold()

      Returns number of events which have exceeded the configured alert threshold.